/* SOURCE CONTROL INFORMATION

	    $RCSfile: bior.h,v $
	    $Revision: 1.3 $
	    Modified $Date: 1994/02/08 23:12:10 $
	    @(#) $Source: /usr2/meade/bior/RCS/bior.h,v $
	    $Author: meade $
*/

/* COMPONENT BIOR_H	Biorhythm Definitions
*/

/* DESCRIPTION
This is the support file for bior.c, containing needed definitions
and macros.
*/

/* ASSUMPTIONS and LIMITATIONS
The macros contained herein depend upon certain global variables
in the C source file.
*/

/* DATA ORGANIZATION
*/
/****************************************************************/
#if !defined(__MSDOS__)
#ident "@(#) $Id: bior.h,v 1.3 1994/02/08 23:12:10 meade Exp meade $"
#endif

/****************************************
 *	General Definitions		*
 ****************************************/
#define	PI		3.1415926535	/* the classic value		*/
#define	GRAPH_WIDTH	51		/* width of biorhythm chart	*/
#define	DEF_CHART_DAYS	20		/* default to 20 days charting	*/

#define	DEF_BIRTHDATE	"12.04.65"	/* substitute your birthdate	*/

#define	PHYS_CYCLE	23.0		/* the physical cycle period	*/
#define	EMOT_CYCLE	28.0		/* the emotional cycle period	*/
#define	MENT_CYCLE	33.0		/* the mental cycle period	*/

typedef enum { FALSE, TRUE } bool;	/* boolean type			*/

/****************************************
 *	Macro Definitons		*
 ****************************************/
#define PHYSICAL	(int)(50 * (1.0 + sin (modf (elapsed_days / PHYS_CYCLE, &ipart) * 360.0 * PI / 180.0)))
#define EMOTIONAL	(int)(50 * (1.0 + sin (modf (elapsed_days / EMOT_CYCLE, &ipart) * 360.0 * PI / 180.0)))
#define MENTAL		(int)(50 * (1.0 + sin (modf (elapsed_days / MENT_CYCLE, &ipart) * 360.0 * PI / 180.0)))

/****************************************
 *	Date Structure Definition	*
 ****************************************/

typedef struct				/* struct to hold date data	*/
  {
  long	day;				/* 1 - 31			*/
  long	month;				/* 1 - 12			*/
  long	year;				/* 00 - 99 (1900's assumed)	*/
  long	julian;				/* comp julian date (in days)	*/
  } DATE;
