/*
 *
 *
 * Biorhythmus (c) by Frank Kaefer 1987-1994 V3.0
 * History:
 *          V1.0 ZX-80 Basic (ZX-80 with 16 kB RAM)
 *          V2.0 TRS-80 Basic (Video Genie)
 *          V2.1 C-64 Basic
 *          V2.2 OS-9 Basic (OS-9/68000 on Atari ST)
 *          V3.0 GW-Basic
 */
#include <stdio.h>
#include <time.h>
#include <math.h>

#define   PI 3.14159265
#define   TRUE 1
#define   FALSE 0

char  *WOCHENTAG[]={"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};

int  MONATSTAG[] = {31,28,31,30,31,30,31,31,30,31,30,31};

int	T, M, J;	/*T=day M=month J=year*/
int	TG, MG, JG;
int	TH, MH, JH;
int	TA;
int	TAG, TAH, TAGE;
int	GTAG, KTAGE, PHYS, EMOT, GEIST;
int	P, E, G, CL, PL;



main ()
{
	char	DTMP[BUFSIZ], AUSGABEART[BUFSIZ];
	char	c, c2;

	/* Start */

 	printf ("\nBiorhythm (c) 1987-1994 V3.0\n");

	/* ----------------------------------------------------------------*/
  	/* Eingabe des heutigen Datums */
	/* ----------------------------------------------------------------*/
  	printf("\nDate     [<RETURN> for Systemdate] (DD.MM.YYYY) : ");
  	gets (DTMP);

  	if (strlen (DTMP) != 10) {
		getdate (DTMP);
	}

	sscanf (DTMP, "%2d%c%2d%c%4d", &T, &c, &M, &c2, &J);
  	TH=T;
  	MH=M;
  	JH=J;
  
	/*------------------------------------------------------------------*/
  	/* Eingabe des Geburtstages */
	/*------------------------------------------------------------------*/
  	printf ("Birthday [<RETURN> for 09.04.1956] (DD.MM.YYYY) : ");
  	gets (DTMP);

  	if (strlen (DTMP) != 10) {
		 strcpy (DTMP, "09.04.1956");
	}

	sscanf (DTMP, "%2d%c%2d%c%4d", &T, &c, &M, &c2, &J);
  	TG=T;
  	MG=M;
  	JG=J;

  	sub_1170 ();

  	TA=TA-(TA/7)*7;
  	GTAG=TA+1;
  	/* ---------------------------------------------------------------*/
  	/* Abfrage, ob und wo Kurve oder Tageswerte ausgegeben werden sollen */
  	/* ---------------------------------------------------------------*/
	printf ("\n");
  	printf ("Values for today or Graph   [<RETURN> for Graph]  (v/g) ");
  	gets (AUSGABEART);
  	if (AUSGABEART[0]=='v') {
		sub_720 ();
	} else {
  		sub_1320 ();
	}

}

int
sub_720 ()
{
	float	real_age;

  	/* ----------------------------------*/
  	/* Berechnung der vergangenen Tage */
  	/* ----------------------------------*/
  	J=JG;
  	M=MG;
  	T=TG;
  	sub_1170 ();
  	TAG=TA;
  	J=JH;
  	M=MH;
  	T=TH;
  	sub_1170 ();
  	TAH=TA;
  	TAGE=TAH-TAG;
  	sub_2110 ();

  	printf ("\nThe birthday %d.%d.%d is a %s\n", 
                 TG, MG, JG, WOCHENTAG[GTAG]);
  	printf ("\nAge in days: %d\n ", TAGE);

	real_age = (float) TAGE;

  	/* --------------------------------------------------------------*/
  	/* Berechnung der drei Werte fuer das angegebene Datum */
  	/* --------------------------------------------------------------*/
  	PHYS=(int)(50.0*(1.0+sin((real_age/23.0-(int)(real_age/23.0))*360.0*PI/180.0)));
  	EMOT=(int)(50.0*(1.0+sin((real_age/28.0-(int)(real_age/28.0))*360.0*PI/180.0)));
  	GEIST=(int)(50.0*(1.0+sin((real_age/33.0-(int)(real_age/33.0))*360.0*PI/180.0)));

 	/* --------------------------------------------------------------*/
 	/* Ausgabe der Werte*/
 	/* --------------------------------------------------------------*/

 	printf ("Biorhythm   %d.%d.%d\n\n", TH,MH,JH);
 	printf ("Physical:   %% %d \n", PHYS);
 	printf ("Emotional:  %% %d\n", EMOT);
 	printf ("Mental:     %% %d\n\n", GEIST);
}



int
sub_1320 ()
{
 	char GRAPH[52];
	char	days[10];
	float  Z;

 	/* -----------------------------------------------------------------*/
 	/* Ausgabe einer Kurve*/
 	/* -----------------------------------------------------------------*/
 	printf ("\nGraph for how many days : ");
 	gets (days);
	sscanf (days, "%d", &KTAGE);
 	KTAGE=KTAGE-1;

 	/* -----------------------------------------------------------------*/
 	/* Berechnung der vergangenen Tage*/
 	/* -----------------------------------------------------------------*/
 	J=JG;
 	M=MG;
 	T=TG;
 	sub_1170 ();
 	TAG=TA;
 	J=JH;
 	M=MH;
 	T=TH;
 	sub_1170 ();
 	TAH=TA;
 	TAGE=TAH-TAG;

 	sub_2110 ();
 	printf ("The birthday %d.%d.%d is a %s\n", TG, MG, JG, WOCHENTAG[GTAG]);
 	printf ("Age in days: %d\n", TAGE);
 	printf ("\tP=Physical, E=Emotional, M=Mental\n");
 	printf ("\tbad condition\t\t\tgood condition\n");

 	/*---------------------------------------------------------------*/
 	/* Schleife fuer die Ausgabe der Kurve*/
 	/* --------------------------------------------------------------*/
 	for (Z=(float)TAGE; Z <= (float)(TAGE+KTAGE) ; ++Z) {
  		PHYS=(int)(50.0*(1.0+sin((Z/23.0-(int)(Z/23.0))*360.0*PI/180.0)));
  		EMOT=(int)(50.0*(1.0+sin((Z/28.0-(int)(Z/28.0))*360.0*PI/180.0)));
  		GEIST=(int)(50.0*(1.0+sin((Z/33.0-(int)(Z/33.0))*360.0*PI/180.0)));

 		/* ---------------------------------------------------*/
 		/* Ausgabe der Werte als Kurve*/
 		/* ---------------------------------------------------*/
 		printf ("\n%d.%d.%d\t", TH, MH, JH);
 		PHYS=(int)((int)(PHYS)/2+.5);
 		EMOT=(int)((int)(EMOT)/2+.5);
 		GEIST=(int)((int)(GEIST)/2+.5);
 		P=PHYS+1;
 		E=EMOT+1;
 		G=GEIST+1;

 		for (CL=0; CL <=51; ++CL) {
 			GRAPH[CL]='.';
 		}
 		GRAPH[P]='P';
 		GRAPH[E]='E';
 		GRAPH[G]='M';
 		GRAPH[25]='|';

 		for (PL=0; PL <= 51; ++PL) {
 			printf ("%c", GRAPH[PL]);
 		}

 		TH=TH+1;
 		if (TH>MONATSTAG[MH]) {
			MH=MH+1;
			TH=1;
 		}

 		if (MH>12) {
			JH=JH+1;
			MH=1;
 		}
	}
	printf ("\n");
}


int
sub_2110 ()
{
 	/* Kopf BIORHYTHMUS*/
 	/* ------------------------------------------------------------*/
 	printf ("\tBIORHYTHM\n");
 	printf ("\t=========\n");
 	printf ("\t(c) 1987-1994 by Frank Kaefer\n");
 	return;
}



int
sub_1170 ()
{
 	TA=0;
 	if (M<=2) {
		TA=(M-1)*31;
		goto jump;
	}
 	if (J/4==(int)(J/4)) {
		TA=1;
	}
 	if (J/100==(int)(J/100)) {
		TA=0;
	}
 	if (J/400==(int)(J/400)) {
		TA=1;
	}
 	TA=TA+((306*M-324)/10);

jump: 	TA=TA+(J-1)*365+ (int)((J-1)/4);
 	TA=TA- (int)((J-1)/100)+ (int)((J-1)/400);
 	TA=TA+T;
 	return;
}


int
getdate (date)
char	*date;
{
        struct  tm      tm, *tptr;
        time_t  time_secs;

        tptr = &tm;

        time_secs = time (NULL);

        tptr = localtime ( &time_secs);

        strftime (date, BUFSIZ, "%d:%m:%Y", tptr);
}
