/* --------------------------------------------------------------------
 Biorhythmus (c) by Frank Kaefer 1987-1994 V3.0
 History:
          V1.0 ZX-80 Basic (ZX-80 with 16 kB RAM)
          V2.0 TRS-80 Basic (Video Genie)
          V2.1 C-64 Basic
          V2.2 OS-9 Basic (OS-9/68000 on Atari ST)
          V3.0 GW-Basic
        H.Mori C 1994.10.27 --- Compile: gcc br.c -o br -lm ---
        Funayama "Gregory" Ryuji 1995.8.27
 -------------------------------------------------------------------- */
#include <stdio.h>
#include <sys/types.h>
#include <time.h>
#include <math.h>

float	PI = 3.14159265;

/* --------------------------------------------------------------------
 Daten aus den Datazeilen lesen
 -------------------------------------------------------------------- */
int	J,M,T,TA ;
static int MONATSTAG[12] = {31,28,31,30,31,30,31,31,30,31,30,31};
static char *WOCHENTAG[7] = {"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
static char *strd[2] = { "<img alt=\".\" src=\"/~ryuuji-f/biorhythm/unit.gif\">", "." } ;
static char *strP[2] = { "<img alt=\"P\" src=\"/~ryuuji-f/biorhythm/blueball.gif\">", "P" } ;
static char *strE[2] = { "<img alt=\"E\" src=\"/~ryuuji-f/biorhythm/greenball.gif\">", "E" } ;
static char *strM[2] = { "<img alt=\"M\" src=\"/~ryuuji-f/biorhythm/redball.gif\">", "M" } ;
static char *strl[2] = { "<img alt=\"|\" src=\"/~ryuuji-f/biorhythm/bar.gif\">", "|" } ;
static char *strcond[2] = { "<img alt=\"Bad condition                                  Good condition\" src=\"/~ryuuji-f/biorhythm/condition.gif\">\n\n", "Bad condition                        Good condition" } ;
static char *strtoday[2] = { "<img alt=\"<- TODAY\" align=bottom src=\"/~ryuuji-f/biorhythm/today.gif\">", "<- TODAY" } ;

/* --------------------------------------------------------------------
 Unterprogramm zur Berechnung der vergangenen Tage
 -------------------------------------------------------------------- */
void gosub_start(void)
{
    TA = 0;
    if (M <= 2)
	TA = (M-1) * 31;
    else {
	if (J%4 == 0)
	    TA = 1;
	if (J%100 == 0)
	    TA = 0;
	if (J%400 == 0)
	    TA = 1;
	TA += (int)((306*M-324)/10);
    }

    TA += ((J-1)*365 + (int)((J-1)/4));
    TA += ((int)((J-1)/400) - (int)((J-1)/100));
    TA += T;

    return;
}

/* --------------------------------------------------------------------
 Start
 -------------------------------------------------------------------- */
int main(int argc, char *argv[])
{
    int		JH,MH,TH,JG,MG,TG, GTAG;
    int		KTAGE, TAG, TAH, TAGE;
    int		Z, PHYS, EMOT, GEIST;
    int		P,E,G, CL,PL;
    int	negd, posd, nowy, nowm, nowd ;
    char	GRAPH[51];
    struct tm	*today, *stoday;
    time_t	t_time, st_time;
    int type ; /* 1995.8.30 Funayama "Gregory" Ryuji */
    int width ; /* 1995.8.30 Funayama "Gregory" Ryuji */

    if (argc != 7) {
	printf("<TITLE>Biorhythm</TITLE>\n");
	printf("Please input your birthday collectly.\n");
	exit(1);
    }

    negd = atoi (argv[4]) ; /* 1995.8.27 Funayama "Gregory" Ryuji */
    posd = atoi (argv[5]) ; /* 1995.8.27 Funayama "Gregory" Ryuji */
    type = atoi (argv[6]) ; /* 1995.8.30 Funayama "Gregory" Ryuji */
    if ( type > 1 ) type = 1 ; /* 1995.8.30 Funayama "Gregory" Ryuji */
    width = (type == 0) ? 40 : 50 ; /* 1995.8.30 Funayama "Gregory" Ryuji */

/* --------------------------------------------------------------------
 Eingabe des heutigen Datums
 -------------------------------------------------------------------- */
    st_time = time((time_t *)0);
    t_time = st_time + negd * 24 * 60 * 60 ; /* 1995.8.27 */

    today = localtime(&t_time);
    T = today->tm_mday;
    M = today->tm_mon + 1;
    J = today->tm_year + 1900;

    stoday = localtime(&st_time);
    nowd = stoday->tm_mday;
    nowm = stoday->tm_mon + 1;
    nowy = stoday->tm_year + 1900;

    TH = T;
    MH = M;
    JH = J;

/* --------------------------------------------------------------------
 Eingabe des Geburtstages
 -------------------------------------------------------------------- */
    J = atoi(argv[1]);
    M = atoi(argv[2]);
    T = atoi(argv[3]);

    if (J < 100)
	J += 1900;

    if ((M < 1) || (M > 12) || (T < 1) || (T > 31)) {
	printf("<TITLE>Biorhythm</TITLE>\n");
	printf("Please input your birthday collectly.\n");
	exit(1);
    }

    TG = T;
    MG = M;
    JG = J;

    gosub_start();

    TA = TA - (int)(TA/7) * 7;
    GTAG = TA;

/* --------------------------------------------------------------------
 Ausgabe einer Kurve
 -------------------------------------------------------------------- */
    KTAGE = posd-negd; /* 1995.8.27 */
    KTAGE = KTAGE - 1;

/* --------------------------------------------------------------------
 Berechnung der vergangenen Tage
 -------------------------------------------------------------------- */
    J = JG;
    M = MG;
    T = TG;

    gosub_start();

    TAG = TA;
    J = JH;
    M = MH;
    T = TH;

    gosub_start();

    TAH = TA;
    TAGE = TAH - TAG;

/* --------------------------------------------------------------------
 Kopf BIORHYTHMUS
 -------------------------------------------------------------------- */
    printf("<TITLE>WeBiorhythm by Funayama \"Gregory\" Ryuji</TITLE>\n");
    printf ( "<center>" ) ;
    printf("<h1>WeBiorhythm</h1>");
    printf ( "</center>\n" ) ;

    printf("<p>");
    printf("The birthday : %d.%d.%d.(%s)<br>\n", JG, MG, TG, WOCHENTAG[GTAG]);
    printf("Age in days : %d<p>\n", TAGE);
    printf("<p>");
    printf ( "<center>\n" ) ;
    printf("%s = Physical   %s = Emotional   %s = Mental\n", strP[type], strE[type], strM[type]);
    printf ( "</center>\n" ) ;
    printf("<pre>\n\n");
    printf("            %s", strcond[type]) ;

/* --------------------------------------------------------------------
 Schleife fuer die Ausgabe der Kurve
 -------------------------------------------------------------------- */
    for (Z = TAGE; Z <= TAGE+KTAGE; Z++) {
	PHYS = (int)(width*(1+sin((((float)Z/23)-(int)(Z/23))*360*PI/180)));
	EMOT = (int)(width*(1+sin((((float)Z/28)-(int)(Z/28))*360*PI/180)));
	GEIST = (int)(width*(1+sin((((float)Z/33)-(int)(Z/33))*360*PI/180)));

/* --------------------------------------------------------------------
 Ausgabe der Werte als Kurve
 -------------------------------------------------------------------- */
	if ( nowy == JH && nowm == MH && nowd == TH && type == 1 )
	  printf ( "\n" ) ;
	printf("%4d.%2d.%2d", JH,MH,TH);
	printf("  ");
	PHYS = (int)((PHYS+1)/2);
	EMOT = (int)((EMOT+1)/2);
	GEIST = (int)((GEIST+1)/2);
	P = PHYS;
	E = EMOT;
	G = GEIST;
/* -------------------------------------------------------------------- */
	for (CL = 0; CL <= width; CL++)
          GRAPH[CL] = '.';
	GRAPH[width/2] = '|';
	GRAPH[P] = 'P';
	GRAPH[E] = 'E';
	GRAPH[G] = 'M';
      for (PL = 0; PL <= width; PL++){
	switch ( GRAPH[PL]) {
	  case '.': printf ( "%s", strd[type] ) ;
	            break ;
	  case 'P': printf ( "%s", strP[type] ) ;
	            break ;
	  case 'E': printf ( "%s", strE[type] ) ;
	            break ;
	  case 'M': printf ( "%s", strM[type] ) ;
	            break ;
	  case '|': printf ( "%s", strl[type] ) ;
	            break ;
	}
      }

	if ( nowy == JH && nowm == MH && nowd == TH )
	  printf ( " %s", strtoday[type] ) ;

	printf("\n");
/* -------------------------------------------------------------------- */
	TH = TH + 1;
	if (TH > MONATSTAG[MH-1]) {
	    MH = MH + 1;
	    TH = 1;
	}
	if (MH > 12) {
	    JH = JH + 1;
	    MH = 1;
	}
    }

    printf("</pre>");
    printf("<hr>");
    printf("<address>");
    printf("Funayama \"Gregory\" Ryuji &lt; ryuuji-f@is.aist-nara.ac.jp &gt;");
    printf("</address>");
    return 0;
}
